#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_fish_scheme.h"
#include "FileEncrypt.h"
std::auto_ptr<M_fish_scheme> M_fish_scheme::msSingleton(nullptr);

int M_fish_scheme::GetCount()
{
	return (int)mMapData.size();
}

const M_fish_schemeData* M_fish_scheme::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_fish_schemeData>& M_fish_scheme::GetMapData()
{
	return mMapData;
}

void M_fish_scheme::Reload()
{
	mMapData.clear();
	Load();
}

void M_fish_scheme::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_fish_schemeData data;
		data.mID = element->IntAttribute("ID");
		data.mmonster_id = element->IntAttribute("monster_id");
		data.mfish_group = element->IntAttribute("fish_group");
		data.mnum = element->IntAttribute("num");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_fish_scheme::Load()
{
	Load("../Config/M_fish_scheme.xml");
}

M_fish_scheme* M_fish_scheme::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_fish_scheme());
	}
	return msSingleton.get();
}
